#include <windows.h>
#include <stdio.h>
#include "wkLocalizer.h"

extern char** Table14[];
extern char* StringTable[];
extern char** ResStrTable[];

char* StringsHeap=0;
extern LANG_DEF* Langs[];

extern void CleanResTable(void);
extern void AddRes(DWORD ID, char* str);

void FreeAll()
{
	if(StringsHeap!=0) free(StringsHeap); StringsHeap=0;
	for(int i=0;i<15;i++) if(Table14[i]!=0) { free(Table14[i]); Table14[i]=0;}

	for(int i=0x5;i<=0xD;i++) if(StringTable[i]) free(StringTable[i]);
	if(StringTable[0xF]) free(StringTable[0xF]);
	for(int i=0xB8;i<=0xC0;i++) if(StringTable[i]) free(StringTable[i]);

	memset(StringTable,0,200*sizeof(char*));
	CleanResTable();
}

DWORD GetLastFree(char** Tbl)
{
	DWORD i=0;
	while(Tbl[i])i++;
	return i;
}

void LoadLang()
{
	FreeAll();
	WaLCID=Langs[WaLangId]->LCID;
	if(Langs[WaLangId]->FileName)
	{
		FILE* F=fopen(Langs[WaLangId]->FileName,"rb");
			WALNGHEAD Head;
		
			if(!fread(&Head,sizeof(Head),1,F));

			fseek(F,0,SEEK_END);
			DWORD Size=ftell(F)-Head.StringHeapOffset;
			StringsHeap=(char*)malloc(Size);
			
			fseek(F,Head.StringHeapOffset,SEEK_SET);
			fread(StringsHeap,Size,1,F);

			fseek(F,sizeof(Head),SEEK_SET);

			DWORD ID;
			fread(&ID,sizeof(ID),1,F);
			while(ID!=0xFFFFFFFF)
			{
				DWORD Type;
				fread(&Type,sizeof(Type),1,F);

				DWORD Class=ID/0x1000000;
				DWORD SID=(ID%0x1000000)/0x100;
				DWORD Sub=ID%0x100;
				switch (Class)
				{
				case 1:
				{
					DWORD Offset;
					fread(&Offset,sizeof(Offset),1,F);
					if(Offset!=0xFFFFFFFF){
						char* Adr=StringsHeap+Offset;
						AddRes(SID,Adr);
					}
					if(Type==1)	while(Offset!=0xFFFFFFFF) fread(&Offset,sizeof(Offset),1,F);
				}break;
				case 2:
				{
					DWORD Offset;
					fread(&Offset,sizeof(Offset),1,F);

					if((SID>=0x5&&SID<=0xF)||(SID>=0xB8&&SID<=0xC0))
					{
						if(SID==0xE)
						{
							if(!Table14[Sub]) 
							{
								Table14[Sub]=(char**)malloc(sizeof(char*)*256);
								memset(Table14[Sub],0,sizeof(char*)*256);
							}
							if(Offset!=0xFFFFFFFF){
								char* Adr=StringsHeap+Offset;
								Table14[Sub][GetLastFree(Table14[Sub])]=Adr;
							}
							if(Type==1)	
								while(1&&Offset!=0xFFFFFFFF) 
								{
									fread(&Offset,sizeof(Offset),1,F);
									if(Offset==0xFFFFFFFF)break;
									char* Adr=StringsHeap+Offset;
									Table14[Sub][GetLastFree(Table14[Sub])]=Adr;
								}
						}
						else
						{

							if(!StringTable[SID]) 
							{
								StringTable[SID]=(char*)malloc(sizeof(char*)*256);
								memset(StringTable[SID],0,sizeof(char*)*256);
							}
							if(Offset!=0xFFFFFFFF){
								char* Adr=StringsHeap+Offset;
								((char**)StringTable[SID])[GetLastFree((char**)StringTable[SID])]=Adr;
							}
							if(Type==1)	
								while(1&&Offset!=0xFFFFFFFF) 
								{
									fread(&Offset,sizeof(Offset),1,F);
									if(Offset==0xFFFFFFFF)break;
									char* Adr=StringsHeap+Offset;
									((char**)StringTable[SID])[GetLastFree((char**)StringTable[SID])]=Adr;
								}
						}
					}
					else if(SID<0xC1)
					{
						if(Offset!=0xFFFFFFFF){
							char* Adr=StringsHeap+Offset;
							StringTable[SID]=Adr;
						}
					}
					else if(Type==1) while(Offset!=0xFFFFFFFF) fread(&Offset,sizeof(Offset),1,F);
				}break;
				default:
				{
					DWORD Offset;
					fread(&Offset,sizeof(Offset),1,F);
					if(Type==1)	while(Offset!=0xFFFFFFFF) fread(&Offset,sizeof(Offset),1,F);
				}
				}

				fread(&ID,sizeof(ID),1,F);
			}
			fclose(F);
	}
}